package xpbook;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

import org.apache.cactus.*;
import junit.framework.*;

/**
 * $Revision: 1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/28 20:28:05 $.
 * Implementation of example application from "Java Tools for Extreme Programming" by Hightower/Lesiecki.
 * Test case for exercising Cactus tests and simple Cactus WebResponse response. 
 */
public class ChildTagTest extends JspTestCase {
    
    public ChildTagTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(ChildTagTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    private ChildTag tag;
    private ParentTag parentTag;
    private BodyContent tempOut;
    
    public void setUp() {
        parentTag = new ParentTag();
        parentTag.setPageContext(this.pageContext);
        parentTag.setName("Test Parent");
        parentTag.doStartTag();
        
        tag = new ChildTag();
        tag.setPageContext(this.pageContext);
        tag.setParent(parentTag); // Here the hierarchy is defined.
        
        tempOut = pageContext.pushBody();
    }
    
    public void testDoStartTag() throws JspException {
        tag.doStartTag();
        assertTrue(parentTag.getContainsChildren());
        
        String startTagOutput = tempOut.getString();
        String expectedString = "<br>I am a child nested in Test Parent.\n";
        assertEquals(expectedString.trim(), startTagOutput.trim());
    }
}
