package xpbook;

import org.apache.cactus.*;
import javax.servlet.jsp.JspException;
import java.io.IOException;
import junit.framework.*;

/**
 * $Revision: 1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/27 04:35:19 $.
 * Modified version of example application from "Java Tools for Extreme Programming" by Hightower/Lesiecki.
 * Test case for exercising Cactus tests and simple Cactus WebResponse response. 
 */
public class HelloTagTest extends JspTestCase {
    
    public HelloTagTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(HelloTagTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    private HelloTag tag;
    
    /** 
     *
     */
    public void beginDoStartTag(WebRequest clientSideRequest) {
         System.out.println("beginDoStartTag() was called.");
    }
    
    /** This is the server-side set-up for all methods */
    public void setUp() {
        System.out.println("setUp() was called.");
        tag = new HelloTag();
        tag.setPageContext(this.pageContext);
    }
    
    /** Executed on the server side */
    public void testDoStartTag() throws JspException {
        System.out.println("testDoStartTag() was called.");
        int result = tag.doStartTag();
        assertEquals(tag.SKIP_BODY, result);
    }
    
    /** This is the server-side finalization for all methods */
    public void tearDown() {
        System.out.println("tearDown() was called.");
    }
    
    /** 
      *
      */
    public void endDoGet(WebResponse receivedResponse) {
        System.out.println("endDoStartTag() was called");
        String expected = "Hello JSP Tag!";
        String response = receivedResponse.getText();
        assertTrue(response.indexOf(expected) != -1);
    }

}
