package xpbook;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

import org.apache.cactus.*;
import com.meterware.httpunit.WebResponse;
import com.meterware.httpunit.WebLink;
import junit.framework.*;

/**
 * $Revision: 1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/28 20:28:06 $.
 * Implementation of example application from "Java Tools for Extreme Programming" by Hightower/Lesiecki.
 * Test case for exercising Cactus tests and simple Cactus WebResponse response. 
 */
public class ProductLinkTagTest extends JspTestCase {
    
    public ProductLinkTagTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(ProductLinkTagTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    private ProductLinkTag tag;
    private String fakeProductId = "55";
    private String fakeLinkText = "Elf detector";
    private String fakeLinkTarget = "productLinkTag.jsp?id=55";
    
    public void beginDoAfterBody(WebRequest webRequest) {
        //webRequest.addParameter("55", "Elf detector");
    }
    
    public void setUp() throws JspException {
        tag = new ProductLinkTag();
        tag.setPageContext(this.pageContext); // this is mandatory
        out = pageContext.pushBody();  // level 1
        tag.setBodyContent((BodyContent) out);
        tag.doInitBody();  // not necessary, in this specific case
    }
    
    public void testDoAfterBody() throws JspException, java.io.IOException {
        tag.setProductId(fakeProductId); // normally set in beginXXX()
        out.println(fakeLinkText);
        assertEquals(tag.SKIP_BODY, tag.doAfterBody());
    }
    
    public void tearDown() {
        pageContext.popBody();
    }
    
    /**
     * Uses HttpUnit's WebResponse
     */
    public void endDoAfterBody(com.meterware.httpunit.WebResponse webResponse) throws org.xml.sax.SAXException {
        WebLink link = webResponse.getLinkWith(fakeLinkText);
        assertNotNull(link);
        String pointsTo = link.getURLString();
        assertEquals(fakeLinkTarget, pointsTo);
    }
}
